"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class SamplesInfo(ProtocolElement):
    """
    ReportedVsGeneticSummary ========================================
    General information about the checks, versions, tools, and number
    of markers
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "deliveryId",
        "participantId",
        "sampleId",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_13 import metrics as metrics_1_2_2

        return {
            "org.gel.models.metrics.avro.SamplesInfo": metrics_1_2_2.SamplesInfo,
        }

    __slots__ = [
        "deliveryId",
        "participantId",
        "sampleId",
    ]

    def __init__(
        self,
        deliveryId,
        participantId,
        sampleId,
        validate=None,
        **kwargs
    ):
        """Initialise the metrics_1_2_2.SamplesInfo model.

        :param deliveryId:
            Delivery Id
        :type deliveryId: str
        :param participantId:
            Participant Id: This code should be unique per patient and independent
            of the sample
        :type participantId: str
        :param sampleId:
            Sample Id (e.g, LP00012645_5GH))
        :type sampleId: str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.2.2"
